--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Alchemy skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "ALCM"
local ALCM, prevALCM = 0.0, -2
local ALCMmax, preALCMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["alchemy"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2 = GetProfessions();

	local skillLevel = 0
	local maxSkillLevel = 0

	if prof1 then
		local name, _, level, maxLevel = GetProfessionInfo(prof1)
		if name == L["alchemy"] then
			skillLevel = level
			maxSkillLevel = maxLevel
		elseif prof2 then
			name, _, level, maxLevel = GetProfessionInfo(prof2)
			if name == L["alchemy"] then
				skillLevel = level
				maxSkillLevel = maxLevel
			end
		end
	end

	ALCM = skillLevel
	ALCMmax = maxSkillLevel
	if not startskill then startskill = skillLevel end

	if ALCM == prevALCM and ALCMmax == preALCMmax then
		return
	end

	preALCMmax = ALCMmax
	prevALCM = ALCM

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local ALCMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..ALCMmax
	end

	local BarBalanceText = ""
	if ALCMmax ~= 0 and (ALCM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(ALCM - startskill).."]"
	end

	if ALCM == 700 then
		ALCMtext = "|cFF69FF69"..L["maximum"]
	elseif ALCMmax == 0 then
		ALCMtext = "|cFFFF2e2e"..L["noprof"]
	elseif ALCM == ALCMmax then
		ALCMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		ALCMtext = "|cFFFFFFFF"..ALCM..HideText..BarBalanceText
	end
	return L["alchemy"]..": ", ALCMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if not ALCM then
		ColorValueAccount = ""
	elseif ALCM == 700 then
		ColorValueAccount = ""
	elseif (ALCM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (ALCM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(ALCM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if ALCM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["alchemy"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFccce00 "..L["alchemy"].."|r".." Multi",
	tooltip = L["alchemy"],
	icon = "Interface\\Icons\\Trade_alchemy.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
