--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Archaeology Fragments.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local ACE = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_ARFGM"
local ICON = "Interface\\Icons\\inv_misc_shovel_01"

local dwarfCount, dwarfMaximum, dwarfRequired = 0, 0, 0  -- Quantia de frasgmentos que você tem, o máximo e o requerido para completar o fragmento.
local draeneiCount, draeneiMaximum, draeneiRequired = 0, 0, 0
local fossilCount, fossilMaximum, fossilRequired = 0, 0, 0
local nightElfCount, nightElfMaximum, nightElfRequired = 0, 0, 0
local nerubianCount, nerubianMaximum, nerubianRequired = 0, 0, 0
local orcCount, orcMaximum, orcRequired = 0, 0, 0
local tolvirCount, tolvirMaximum, tolvirRequired = 0, 0, 0
local trollCount, trollMaximum, trollRequired = 0, 0, 0
local vrykulCount, vrykulMaximum, vrykulRequired = 0, 0, 0
local mantidCount, mantidMaximum, mantidRequired = 0, 0, 0
local pandarenCount, pandarenMaximum, pandarenRequired = 0, 0, 0
local moguCount, moguMaximum, moguRequired = 0, 0, 0
local arakkoaCount, arakkoaMaximum, arakkoaRequired = 0, 0, 0
local draenorClansCount, draenorClansMaximum, draenorClansRequired = 0, 0, 0
local ogreCount, ogreMaximum, ogreRequired = 0, 0, 0

local dwarfName, draeneiName, fossilName, nightElfName, nerubianName, orcName, tolvirName, trollName, vrykulName, mantidName, pandarenName, moguName, arakkoaName, draenorClansName, ogreName

local DWARFICON = "|TInterface\\Icons\\trade_archaeology_dwarf_artifactfragment:0|t"
local DRAENEIICON = "|TInterface\\Icons\\trade_archaeology_draenei_artifactfragment:0|t"
local FOSSILICON = "|TInterface\\Icons\\trade_archaeology_fossil_fern:0|t"
local NELFICON = "|TInterface\\Icons\\trade_archaeology_highborne_artifactfragment:0|t"
local NERUBIANICON = "|TInterface\\Icons\\trade_archaeology_nerubian_artifactfragment:0|t"
local ORCICON = "|TInterface\\Icons\\trade_archaeology_orc_artifactfragment:0|t"
local TOLVIRICON = "|TInterface\\Icons\\trade_archaeology_titan_fragment:0|t"
local TROLLICON = "|TInterface\\Icons\\trade_archaeology_troll_artifactfragment:0|t"
local VRYKULICON = "|TInterface\\Icons\\trade_archaeology_vrykul_artifactfragment:0|t" -- Mesmo do Pandaren e Mogu
local MANTIDICON = "|TInterface\\Icons\\inv_misc_archaeology_mantidstatue_01:0|t"
local ARAKKOAICON = "|TInterface\\Icons\\achievement_dungeon_arakkoaspires:0|t"
local DCLANICON = "|TInterface\\Icons\\achievement_character_orc_male_brn:0|t"
local OGREICON = "|TInterface\\Icons\\spell_nature_rockbiter:0|t"
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["archaeology"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function UpdateAll(self)
	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(1)

	dwarfRequired = numFragmentsRequired
	dwarfName = raceName
	dwarfCount = numFragmentsCollected
	dwarfMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(2)

	draeneiRequired = numFragmentsRequired
	draeneiName = raceName
	draeneiCount = numFragmentsCollected
	draeneiMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(3)

	fossilRequired = numFragmentsRequired
	fossilName = raceName
	fossilCount = numFragmentsCollected
	fossilMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(4)

	nightElfRequired = numFragmentsRequired
	nightElfName = raceName
	nightElfCount = numFragmentsCollected
	nightElfMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(5)

	nerubianRequired = numFragmentsRequired
	nerubianName = raceName
	nerubianCount = numFragmentsCollected
	nerubianMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(6)

	orcRequired = numFragmentsRequired
	orcName = raceName
	orcCount = numFragmentsCollected
	orcMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(7)

	tolvirRequired = numFragmentsRequired
	tolvirName = raceName
	tolvirCount = numFragmentsCollected
	tolvirMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(8)

	trollRequired = numFragmentsRequired
	trollName = raceName
	trollCount = numFragmentsCollected
	trollMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(9)

	vrykulRequired = numFragmentsRequired
	vrykulName = raceName
	vrykulCount = numFragmentsCollected
	vrykulMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(10)

	mantidRequired = numFragmentsRequired
	mantidName = raceName
	mantidCount = numFragmentsCollected
	mantidMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(11)

	pandarenRequired = numFragmentsRequired
	pandarenName = raceName
	pandarenCount = numFragmentsCollected
	pandarenMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(12)

	moguRequired = numFragmentsRequired
	moguName = raceName
	moguCount = numFragmentsCollected
	moguMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(13)

	arakkoaRequired = numFragmentsRequired
	arakkoaName = raceName
	arakkoaCount = numFragmentsCollected
	arakkoaMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(14)

	draenorClansRequired = numFragmentsRequired
	draenorClansName = raceName
	draenorClansCount = numFragmentsCollected
	draenorClansMaximum = maxFragments

	local raceName, _, _, numFragmentsCollected, numFragmentsRequired, maxFragments = GetArchaeologyRaceInfo(15)

	ogreRequired = numFragmentsRequired
	ogreName = raceName
	ogreCount = numFragmentsCollected
	ogreMaximum = maxFragments

	TitanPanelButton_UpdateButton(self.registry.id)
end
-----------------------------------------------
local eventsTable = {
	CURRENCY_DISPLAY_UPDATE = UpdateAll,
	ARTIFACT_UPDATE = UpdateAll,
	PLAYER_ENTERING_WORLD = UpdateAll
}
-----------------------------------------------
local function GetButtonText(self, id)

	local dwarfText = "|cFFf69112"..dwarfName..":|r "..TitanUtils_GetHighlightText(dwarfCount).."/|cFF69FF69"..dwarfRequired.."|r  "
	if dwarfRequired ~= 0 and dwarfCount >= dwarfRequired then -- Mesmo que você não esteja com a raça na barra, o plugin mostrará quando o artefato estiver pronto para ser feito.
		dwarfText = "|cFFf69112"..dwarfName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Dwarf") then -- Dar track independente de quantidades e etc.
		dwarfText = ""
	end

	local draeneiText = "|cFFf69112"..draeneiName..":|r "..TitanUtils_GetHighlightText(draeneiCount).."/|cFF69FF69"..draeneiRequired.."|r  "
	if draeneiRequired ~= 0 and draeneiCount >= draeneiRequired then
		draeneiText = "|cFFf69112"..draeneiName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Draenei") then
		draeneiText = ""
	end

	local fossilText = "|cFFf69112"..fossilName..":|r "..TitanUtils_GetHighlightText(fossilCount).."/|cFF69FF69"..fossilRequired.."|r  "
	if fossilRequired ~= 0 and fossilCount >= fossilRequired then
		fossilText = "|cFFf69112"..fossilName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Fossil") then
		fossilText = ""
	end

	local nightElfText = "|cFFf69112"..nightElfName..":|r "..TitanUtils_GetHighlightText(nightElfCount).."/|cFF69FF69"..nightElfRequired.."|r  "
	if nightElfRequired ~= 0 and nightElfCount >= nightElfRequired then
		nightElfText = "|cFFf69112"..nightElfName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "NightElf") then
		nightElfText = ""
	end

	local nerubianText = "|cFFf69112"..nerubianName..":|r "..TitanUtils_GetHighlightText(nerubianCount).."/|cFF69FF69"..nerubianRequired.."|r  "
	if nerubianRequired ~= 0 and nerubianCount >= nerubianRequired then
		nerubianText = "|cFFf69112"..nerubianName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Nerubian") then
		nerubianText = ""
	end

	local orcText = "|cFFf69112"..orcName..":|r "..TitanUtils_GetHighlightText(orcCount).."/|cFF69FF69"..orcRequired.."|r  "
	if orcRequired ~= 0 and orcCount >= orcRequired then
		orcText = "|cFFf69112"..orcName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Orc") then
		orcText = ""
	end

	local tolvirText = "|cFFf69112"..tolvirName..":|r "..TitanUtils_GetHighlightText(tolvirCount).."/|cFF69FF69"..tolvirRequired.."|r  "
	if tolvirRequired ~= 0 and tolvirCount >= tolvirRequired then
		tolvirText = "|cFFf69112"..tolvirName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Tolvir") then
		tolvirText = ""
	end

	local trollText = "|cFFf69112"..trollName..":|r "..TitanUtils_GetHighlightText(trollCount).."/|cFF69FF69"..trollRequired.."|r  "
	if trollRequired ~= 0 and trollCount >= trollRequired then
		trollText = "|cFFf69112"..trollName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Troll") then
		trollText = ""
	end

	local vrykulText = "|cFFf69112"..vrykulName..":|r "..TitanUtils_GetHighlightText(vrykulCount).."/|cFF69FF69"..vrykulRequired.."|r  "
	if vrykulRequired ~= 0 and vrykulCount >= vrykulRequired then
		vrykulText = "|cFFf69112"..vrykulName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Vrykul") then
		vrykulText = ""
	end

	local mantidText = "|cFFf69112"..mantidName..":|r "..TitanUtils_GetHighlightText(mantidCount).."/|cFF69FF69"..mantidRequired.."|r  "
	if mantidRequired ~= 0 and mantidCount >= mantidRequired then
		mantidText = "|cFFf69112"..mantidName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Mantid") then
		mantidText = ""
	end

	local pandarenText = "|cFFf69112"..pandarenName..":|r "..TitanUtils_GetHighlightText(pandarenCount).."/|cFF69FF69"..pandarenRequired.."|r  "
	if pandarenRequired ~= 0 and pandarenCount >= pandarenRequired then
		pandarenText = "|cFFf69112"..pandarenName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Pandaren") then
		pandarenText = ""
	end

	local moguText = "|cFFf69112"..moguName..":|r "..TitanUtils_GetHighlightText(moguCount).."/|cFF69FF69"..moguRequired.."|r  "
	if moguRequired ~= 0 and moguCount >= moguRequired then
		moguText = "|cFFf69112"..moguName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Mogu") then
		moguText = ""
	end

	local arakkoaText = "|cFFf69112"..arakkoaName..":|r "..TitanUtils_GetHighlightText(arakkoaCount).."/|cFF69FF69"..arakkoaRequired.."|r  "
	if arakkoaRequired ~= 0 and arakkoaCount >= arakkoaRequired then
		arakkoaText = "|cFFf69112"..arakkoaName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Arakkoa") then
		arakkoaText = ""
	end

	local draenorClansText = "|cFFf69112"..draenorClansName..":|r "..TitanUtils_GetHighlightText(draenorClansCount).."/|cFF69FF69"..draenorClansRequired.."|r  "
	if draenorClansRequired ~= 0 and draenorClansCount >= draenorClansRequired then
		draenorClansText = "|cFFf69112"..draenorClansName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "DraenorClans") then
		draenorClansText = ""
	end

	local ogreText = "|cFFf69112"..ogreName..":|r "..TitanUtils_GetHighlightText(ogreCount).."/|cFF69FF69"..ogreRequired.."|r  "
	if ogreRequired ~= 0 and ogreCount >= ogreRequired then
		ogreText = "|cFFf69112"..ogreName..":|r "..L["ready"]
	elseif not TitanGetVar(ID, "Ogre") then
		ogreText = ""
	end

	return L["fragments"].."  ", dwarfText..draeneiText..fossilText..nightElfText..nerubianText..orcText..tolvirText..trollText..vrykulText..mantidText..pandarenText..moguText..arakkoaText..draenorClansText..ogreText
end
-----------------------------------------------
local function GetTooltipText(self, id)

	if dwarfCount > 0 or draeneiCount > 0 or fossilCount > 0 or nightElfCount > 0 or nerubianCount > 0 or orcCount > 0 or tolvirCount > 0 or trollCount > 0 or vrykulCount > 0 or mantidCount > 0 or pandarenCount > 0 or moguCount > 0 or arakkoaCount > 0 or draenorClansCount > 0 or ogreCount > 0 then
		local dwarfTooltip = "\n"..DWARFICON.."|cFFf69112 "..dwarfName..":|r\t"..TitanUtils_GetHighlightText(dwarfCount).."/|cFF69FF69"..dwarfRequired.."|r\n"
		if dwarfRequired ~= 0 and dwarfCount >= dwarfRequired then -- Modifica o texto quando o artefato está pronto para ser feito. Não mudei nada nos números porque o usuário pode continuar pegando os fragmentos mesmo sem fazer o artefato.
			dwarfTooltip = "\n"..DWARFICON.."|cFFFF2e2e "..dwarfName.."!|r\t"..TitanUtils_GetHighlightText(dwarfCount).."/|cFF69FF69"..dwarfRequired.."|r\n"
		elseif dwarfCount == 0 and dwarfRequired == 0 then -- Se não tiver nada, ele sai da lista.
			dwarfTooltip = "\n"
		end

		local noDwarf = "" -- Essa parte do "no" é para a lista que mostra as raças que o usuário não tem fragmento. Ela fica desativada no menu, mas o usuário pode ativar se quiser.
		if dwarfCount == 0 and dwarfRequired == 0 then
			noDwarf = DWARFICON.."|cFFf69112 "..dwarfName.."\n"
		end

		local draeneiTooltip = DRAENEIICON.."|cFFf69112 "..draeneiName..":|r\t"..TitanUtils_GetHighlightText(draeneiCount).."/|cFF69FF69"..draeneiRequired.."|r\n"
		if draeneiRequired ~= 0 and draeneiCount >= draeneiRequired then
			draeneiTooltip = DRAENEIICON.."|cFFFF2e2e "..draeneiName.."!|r\t"..TitanUtils_GetHighlightText(draeneiCount).."/|cFF69FF69"..draeneiRequired.."|r\n"
		elseif draeneiCount == 0 and draeneiRequired == 0 then
			draeneiTooltip = ""
		end

		local noDraenei = ""
		if draeneiCount == 0 and draeneiRequired == 0 then
			noDraenei = DRAENEIICON.."|cFFf69112 "..draeneiName.."\n"
		end

		local fossilTooltip = FOSSILICON.."|cFFf69112 "..fossilName..":|r\t"..TitanUtils_GetHighlightText(fossilCount).."/|cFF69FF69"..fossilRequired.."|r\n"
		if fossilRequired ~= 0 and fossilCount >= fossilRequired then
			fossilTooltip = FOSSILICON.."|cFFFF2e2e "..fossilName.."!|r\t"..TitanUtils_GetHighlightText(fossilCount).."/|cFF69FF69"..fossilRequired.."|r\n"
		elseif fossilCount == 0 and fossilRequired == 0 then
			fossilTooltip = ""
		end

		local noFossil = ""
		if fossilCount == 0 and fossilRequired == 0 then
			noFossil = FOSSILICON.."|cFFf69112 "..fossilName.."\n"
		end

		local nightElfTooltip = NELFICON.."|cFFf69112 "..nightElfName..":|r\t"..TitanUtils_GetHighlightText(nightElfCount).."/|cFF69FF69"..nightElfRequired.."|r\n"
		if nightElfRequired ~= 0 and nightElfCount >= nightElfRequired then
			nightElfTooltip = NELFICON.."|cFFFF2e2e "..nightElfName.."!|r\t"..TitanUtils_GetHighlightText(nightElfCount).."/|cFF69FF69"..nightElfRequired.."|r\n"
		elseif nightElfCount == 0 and nightElfRequired == 0 then
			nightElfTooltip = ""
		end

		local noNightElf = ""
		if nightElfCount == 0 and nightElfRequired == 0 then
			noNightElf = NELFICON..":|cFFf69112 "..nightElfName.."\n"
		end

		local nerubianTooltip = NERUBIANICON.."|cFFf69112 "..nerubianName..":|r\t"..TitanUtils_GetHighlightText(nerubianCount).."/|cFF69FF69"..nerubianRequired.."|r\n"
		if nerubianRequired ~= 0 and nerubianCount >= nerubianRequired then
			nerubianTooltip = NERUBIANICON.."|cFFFF2e2e "..nerubianfName.."!|r\t"..TitanUtils_GetHighlightText(nerubianCount).."/|cFF69FF69"..nerubianRequired.."|r\n"
		elseif nerubianCount == 0 and nerubianRequired == 0 then
			nerubianTooltip = ""
		end

		local noNerubian = ""
		if nerubianCount == 0 and nerubianRequired == 0 then
			noNerubian = NERUBIANICON.."|cFFf69112 "..nerubianName.."\n"
		end

		local orcTooltip = ORCICON.."|cFFf69112 "..orcName..":|r\t"..TitanUtils_GetHighlightText(orcCount).."/|cFF69FF69"..orcRequired.."|r\n"
		if orcRequired ~= 0 and orcCount >= orcRequired then
			orcTooltip = ORCICON.."|cFFFF2e2e "..orcName.."!|r\t"..TitanUtils_GetHighlightText(orcCount).."/|cFF69FF69"..orcRequired.."|r\n"
		elseif orcCount == 0 and orcRequired == 0 then
			orcTooltip = ""
		end

		local noOrc = ""
		if orcCount == 0 and orcRequired == 0 then
			noOrc = ORCICON.."|cFFf69112 "..orcName.."\n"
		end

		local tolvirTooltip = TOLVIRICON.."|cFFf69112 "..tolvirName..":|r\t"..TitanUtils_GetHighlightText(tolvirCount).."/|cFF69FF69"..tolvirRequired.."|r\n"
		if tolvirRequired ~= 0 and tolvirCount >= tolvirRequired then
			tolvirTooltip = TOLVIRICON.."|cFFFF2e2e "..tolvirName.."!|r\t"..TitanUtils_GetHighlightText(tolvirCount).."/|cFF69FF69"..tolvirRequired.."|r\n"
		elseif tolvirCount == 0 and tolvirRequired == 0 then
			tolvirTooltip = ""
		end

		local noTolvir = ""
		if tolvirCount == 0 and tolvirRequired == 0 then
			noTolvir = TOLVIRICON.."|cFFf69112 "..tolvirName.."\n"
		end

		local trollTooltip = TROLLICON.."|cFFf69112 "..trollName..":|r\t"..TitanUtils_GetHighlightText(trollCount).."/|cFF69FF69"..trollRequired.."|r\n"
		if trollRequired ~= 0 and trollCount >= trollRequired then
			trollTooltip = TROLLICON.."|cFFFF2e2e "..trollName.."!|r\t"..TitanUtils_GetHighlightText(trollCount).."/|cFF69FF69"..trollRequired.."|r\n"
		elseif trollCount == 0 and trollRequired == 0 then
			trollTooltip = ""
		end

		local noTroll = ""
		if trollCount == 0 and trollRequired == 0 then
			noTroll = TROLLICON.."|cFFf69112 "..trollName.."\n"
		end

		local vrykulTooltip = VRYKULICON.."|cFFf69112 "..vrykulName..":|r\t"..TitanUtils_GetHighlightText(vrykulCount).."/|cFF69FF69"..vrykulRequired.."|r\n"
		if vrykulRequired ~= 0 and vrykulCount >= vrykulRequired then
			vrykulTooltip = VRYKULICON.."|cFFFF2e2e "..vrykulName.."!|r\t"..TitanUtils_GetHighlightText(vrykulCount).."/|cFF69FF69"..vrykulRequired.."|r\n"
		elseif vrykulCount == 0 and vrykulRequired == 0 then
			vrykulTooltip = ""
		end

		local noVrykul = ""
		if vrykulCount == 0 and vrykulRequired == 0 then
			noVrykul = VRYKULICON.."|cFFf69112 "..vrykulName.."\n"
		end

		local mantidTooltip = MANTIDICON.."|cFFf69112 "..mantidName..":|r\t"..TitanUtils_GetHighlightText(mantidCount).."/|cFF69FF69"..mantidRequired.."|r\n"
		if mantidRequired ~= 0 and mantidCount >= mantidRequired then
			mantidTooltip = MANTIDICON.."|cFFFF2e2e "..mantidName.."!|r\t"..TitanUtils_GetHighlightText(mantidCount).."/|cFF69FF69"..mantidRequired.."|r\n"
		elseif mantidCount == 0 and mantidRequired == 0 then
			mantidTooltip = ""
		end

		local noMantid = ""
		if mantidCount == 0 and mantidRequired == 0 then
			noMantid = MANTIDICON.."|cFFf69112 "..mantidName.."\n"
		end

		local pandarenTooltip = VRYKULICON.."|cFFf69112 "..pandarenName..":|r\t"..TitanUtils_GetHighlightText(pandarenCount).."/|cFF69FF69"..pandarenRequired.."|r\n"
		if pandarenRequired ~= 0 and pandarenCount >= pandarenRequired then
			pandarenTooltip = VRYKULICON.."|cFFFF2e2e "..pandarenfName.."!|r\t"..TitanUtils_GetHighlightText(pandarenCount).."/|cFF69FF69"..pandarenRequired.."|r\n"
		elseif pandarenCount == 0 and pandarenRequired == 0 then
			pandarenTooltip = ""
		end

		local noPandaren = ""
		if pandarenCount == 0 and pandarenRequired == 0 then
			noPandaren = VRYKULICON.."|cFFf69112 "..pandarenName.."\n"
		end

		local moguTooltip = VRYKULICON.."|cFFf69112 "..moguName..":|r\t"..TitanUtils_GetHighlightText(moguCount).."/|cFF69FF69"..moguRequired.."|r\n"
		if moguRequired ~= 0 and moguCount >= moguRequired then
			moguTooltip = VRYKULICON.."|cFFFF2e2e "..moguName.."!|r\t"..TitanUtils_GetHighlightText(moguCount).."/|cFF69FF69"..moguRequired.."|r\n"
		elseif moguCount == 0 and moguRequired == 0 then
			moguTooltip = ""
		end

		local noMogu = ""
		if moguCount == 0 and moguRequired == 0 then
			noMogu = VRYKULICON.."|cFFf69112 "..moguName.."\n"
		end

		local arakkoaTooltip = ARAKKOAICON.."|cFFf69112 "..arakkoaName..":|r\t"..TitanUtils_GetHighlightText(arakkoaCount).."/|cFF69FF69"..arakkoaRequired.."|r\n"
		if arakkoaRequired ~= 0 and arakkoaCount >= arakkoaRequired then
			arakkoaTooltip = ARAKKOAICON.."|cFFFF2e2e "..arakkoaName.."!|r\t"..TitanUtils_GetHighlightText(arakkoaCount).."/|cFF69FF69"..arakkoaRequired.."|r\n"
		elseif arakkoaCount == 0 and arakkoaRequired == 0 then
			arakkoaTooltip = ""
		end

		local noArakkoa = ""
		if arakkoaCount == 0 and arakkoaRequired == 0 then
			noArakkoa = ARAKKOAICON.."|cFFf69112 "..arakkoaName.."\n"
		end

		local draenorClansTooltip = DCLANICON.."|cFFf69112 "..draenorClansName..":|r\t"..TitanUtils_GetHighlightText(draenorClansCount).."/|cFF69FF69"..draenorClansRequired.."|r\n"
		if draenorClansRequired ~= 0 and draenorClansCount >= draenorClansRequired then
			draenorClansTooltip = DCLANICON.."|cFFFF2e2e "..draenorClansName.."!|r\t"..TitanUtils_GetHighlightText(draenorClansCount).."/|cFF69FF69"..draenorClansRequired.."|r\n"
		elseif draenorClansCount == 0 and draenorClansRequired == 0 then
			draenorClansTooltip = ""
		end

		local noDraenorClans = ""
		if draenorClansCount == 0 and draenorClansRequired == 0 then
			noDraenorClans = DCLANICON.."|cFFf69112 "..draenorClansName.."\n"
		end

		local ogreTooltip = OGREICON.."|cFFf69112 "..ogreName..":|r\t"..TitanUtils_GetHighlightText(ogreCount).."/|cFF69FF69"..ogreRequired.."|r\n"
		if ogreRequired ~= 0 and ogreCount >= ogreRequired then
			ogreTooltip = OGREICON.."|cFFFF2e2e "..ogreName.."!|r\t"..TitanUtils_GetHighlightText(ogreCount).."/|cFF69FF69"..ogreRequired.."|r\n"
		elseif ogreCount == 0 and ogreRequired == 0 then
			ogreTooltip = ""
		end

		local noOgre = ""
		if ogreCount == 0 and ogreRequired == 0 then
			noOgre = OGREICON.."|cFFf69112 "..ogreName.."\n"
		end

		local Hint = L["fragtooltip"] -- Para o usuário esconder a dica.
		if TitanGetVar(ID, "HideHint") then
			Hint = "                                             " -- Esse espaço é para o tolltip não ficar muito justo.
		end

		local NoFragToggle = "" -- Aqui o toggle do "no" para o usuário ver no tooltip quais raças está sem artefato.
		if TitanGetVar(ID, "DisplayNoFrag") then
			NoFragToggle = "\r"..L["nofragments"]..":\n"..noDwarf..noDraenei..noFossil..noNightElf..noNerubian..noOrc..noTolvir..noTroll..noVrykul..noMantid..noPandaren..noMogu..noArakkoa..noDraenorClans..noOgre
		end

		return Hint..L["inprog"]..dwarfTooltip..draeneiTooltip..fossilTooltip..nightElfTooltip..nerubianTooltip..orcTooltip..tolvirTooltip..trollTooltip..vrykulTooltip..mantidTooltip..pandarenTooltip..moguTooltip..arakkoaTooltip..draenorClansTooltip..ogreTooltip..NoFragToggle

	else
		return L["noarchaeology"] -- Retorna se não tem profissão ou artefato.
	end
end
-----------------------------------------------
local function PrepareMenu(self, id)
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[id].menuText)

	if dwarfCount > 0 or draeneiCount > 0 or fossilCount > 0 or nightElfCount > 0 or nerubianCount > 0 or orcCount > 0 or tolvirCount > 0 or trollCount > 0 or vrykulCount > 0 or mantidCount > 0 or pandarenCount > 0 or moguCount > 0 or arakkoaCount > 0 or draenorClansCount > 0 or ogreCount > 0 then -- Condição para aparecer o menu. Apenas se o usuário tiver ao menos 1 fragmento qualquer.
		TitanPanelRightClickMenu_AddToggleIcon(id)
		TitanPanelRightClickMenu_AddToggleLabelText(id)
		TitanPanelRightClickMenu_AddSpacer()
		TitanPanelRightClickMenu_AddTitle(L["tolltip"])

		local info = UIDropDownMenu_CreateInfo();
		info.text = L["hidehint"];
		info.func = function() TitanToggleVar(id, "HideHint"); TitanPanelButton_UpdateButton(id); end
		info.checked = TitanGetVar(id, "HideHint");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = L["displaynofrag"];
		info.func = function() TitanToggleVar(id, "DisplayNoFrag"); TitanPanelButton_UpdateButton(id); end
		info.checked = TitanGetVar(id, "DisplayNoFrag");
		UIDropDownMenu_AddButton(info);

		TitanPanelRightClickMenu_AddSpacer()
		TitanPanelRightClickMenu_AddTitle(L["archfragments"])

		local info = UIDropDownMenu_CreateInfo();
		info.text = dwarfName;
		info.func = function() TitanToggleVar(id, "Dwarf"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Dwarf");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = draeneiName;
		info.func = function() TitanToggleVar(id, "Draenei"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Draenei");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = fossilName;
		info.func = function() TitanToggleVar(id, "Fossil"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Fossil");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = nightElfName;
		info.func = function() TitanToggleVar(id, "NightElf"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "NightElf");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = nerubianName;
		info.func = function() TitanToggleVar(id, "Nerubian"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Nerubian");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = orcName;
		info.func = function() TitanToggleVar(id, "Orc"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Orc");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = tolvirName;
		info.func = function() TitanToggleVar(id, "Tolvir"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Tolvir");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = trollName;
		info.func = function() TitanToggleVar(id, "Troll"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Troll");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = vrykulName;
		info.func = function() TitanToggleVar(id, "Vrykul"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Vrykul");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = mantidName;
		info.func = function() TitanToggleVar(id, "Mantid"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Mantid");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = pandarenName;
		info.func = function() TitanToggleVar(id, "Pandaren"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Pandaren");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = moguName;
		info.func = function() TitanToggleVar(id, "Mogu"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Mogu");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = arakkoaName;
		info.func = function() TitanToggleVar(id, "Arakkoa"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Arakkoa");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = draenorClansName;
		info.func = function() TitanToggleVar(id, "DraenorClans"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "DraenorClans");
		UIDropDownMenu_AddButton(info);

		local info = UIDropDownMenu_CreateInfo();
		info.text = ogreName;
		info.func = function() TitanToggleVar(id, "Ogre"); TitanPanelButton_UpdateButton(id); end
		info.keepShownOnClick = true
		info.checked = TitanGetVar(id, "Ogre");
		UIDropDownMenu_AddButton(info);
	end

	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(ACE["TITAN_PANEL_MENU_HIDE"], id, TITAN_PANEL_MENU_FUNC_HIDE);
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFF05a7ab "..L["archaeology"].."|r [|cFF05a7ab"..L["fragments"].."|r] Multi",
	tooltip = L["fragments"],
	icon = ICON,
	category = "Profession",
	version = version,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	eventsTable = eventsTable,
	prepareMenu = PrepareMenu,
	savedVariables = {
		ShowIcon = 1,
		ShowLabelText = true,
		HideHint = false,
		DisplayNoFrag = false,
		Dwarf = false,
		Draenei = false,
		Fossil = false,
		NightElf = false,
		Nerubian = false,
		Orc = false,
		Tolvir = false,
		Troll = false,
		Vrykul = false,
		Mantid = false,
		Pandaren = false,
		Mogu = false,
		Arakkoa = false,
		DraenorClans = false,
		Ogre = false,
	}
})
